#include "headers.h"

int main(int argc, char **argv)
{
	DEBUG_EVENT			DBEvent;
	STARTUPINFO			si;
	PROCESS_INFORMATION pi; 
	CONTEXT				ctx;
	OPENFILENAME		ofn;
	DWORD dwStartAddr	= 0, dwBreak = 0, dwInstrLen = 0, dwJumpAddr = 0, dwImageBase = 0;
	BYTE bInstrCount	= 0;
	BOOL Status			= FALSE;
	char *lpDexorKey	= NULL;

	memset( &DBEvent, 0, sizeof(DBEvent) );
	memset( &si, 0, sizeof(si) );
	memset( &pi, 0, sizeof(pi) ); 
	memset( &ctx, 0, sizeof(ctx) );
	memset( &ofn, 0, sizeof(ofn) );

	ofn.lpstrFilter = lpFilterString;
	ofn.lpstrFile	= InfectedFile;
	ofn.lStructSize	= sizeof(ofn);
	ofn.nMaxFile	= MAX_PATH;
	ofn.Flags		= OFN_FILEMUSTEXIST | OFN_PATHMUSTEXIST | OFN_LONGNAMES | OFN_EXPLORER | OFN_HIDEREADONLY;

	if(GetOpenFileName(&ofn)!=TRUE) goto fail;
 	wsprintf( CureFile, "%s.cure", InfectedFile );

	Info();	//  

	dwStartAddr = GetModuleStartAddr( InfectedFile, &dwImageBase );			//  EntryPoint  ImageBase
	if( dwStartAddr!=0 ) {
		GetStartupInfo( &si );
		CopyFile( InfectedFile, CureFile, FALSE );							//    
	
		Status = CreateProcess( InfectedFile, NULL, NULL, NULL, FALSE, DEBUG_PROCESS | DEBUG_ONLY_THIS_PROCESS, NULL, NULL, &si, &pi ); //   
		if(!Status) goto fail;
	
		if(!SetBreakpoint( pi.hProcess, (LPVOID)dwStartAddr )) goto fail;	//     
	
		while(1) {
			WaitForDebugEvent(&DBEvent,INFINITE);
			if(DBEvent.dwDebugEventCode == EXCEPTION_DEBUG_EVENT)
			{
				switch(DBEvent.u.Exception.ExceptionRecord.ExceptionCode) {
					case EXCEPTION_BREAKPOINT:
						dwBreak++;
						ctx.ContextFlags = CONTEXT_FULL;
						//       
						GetThreadContext(pi.hThread, &ctx);
						//                   INT 3
						//      EIP       INT 3  1 
						ctx.Eip--;
						if( ctx.Eip == dwStartAddr ) {										//          
							printf( "[+] Breakpoint at start addr: 0x%.8X\n", ctx.Eip );
							RestoreBreakpoint( pi.hProcess, (LPVOID)ctx.Eip );
							dwJumpAddr = SearchEndOfCicle( pi.hProcess, (LPVOID)ctx.Eip );	//       JNZ SHORT						
							SetBreakpoint( pi.hProcess, (LPVOID)dwJumpAddr );				//       JNZ SHORT 			
							SetThreadContext( pi.hThread, &ctx );
							printf( "[+] JNZ found at: 0x%.8X\n", dwJumpAddr );
						} else if( ctx.Eip == dwJumpAddr ) {								//       JNZ SHORT     ZF 
							printf( "[+] ZF flag: %d\r", ctx.EFlags & 0x00000040 );			// ZF=0  , ZF!=0         	
							if( ctx.EFlags & 0x00000040 ) {
								printf("\n");
								SuspendProcess(DBEvent.dwProcessId);
								goto cure;
							}
							RestoreBreakpoint( pi.hProcess, (LPVOID)ctx.Eip );				//                
							ctx.EFlags |= 0x100;											//     .              
							SetThreadContext( pi.hThread, &ctx );							//  SINGLE STEP        
						}
						ContinueDebugEvent( DBEvent.dwProcessId, DBEvent.dwThreadId, DBG_CONTINUE );
						break;
					case EXCEPTION_SINGLE_STEP:
						SetBreakpoint( pi.hProcess, (LPVOID)dwJumpAddr );					//       SINGLE STEP         
						ContinueDebugEvent( DBEvent.dwProcessId, DBEvent.dwThreadId, DBG_CONTINUE );
						break;
					default:
						ContinueDebugEvent(DBEvent.dwProcessId,DBEvent.dwThreadId,DBG_CONTINUE);
						break;
				}
			}
			ContinueDebugEvent( DBEvent.dwProcessId, DBEvent.dwThreadId, DBG_EXCEPTION_NOT_HANDLED );
		}
	}
fail:
	DISP_ERROR();
	return 0;
cure:
	lpDexorKey = CalcDexorKey( pi.hProcess, dwStartAddr, dwImageBase );										//   
	ReadProcessMemory( pi.hProcess, (LPCVOID)((DWORD)dwStartVar + ORIGINAL_EP), (LPVOID)&dwOEP, 4, NULL );	//  OEP  
	dwDecodedOEP = DexorOEP( lpDexorKey, dwOEP );															//  OEP
	CureBinary( pi.hProcess, CureFile, InfectedFile, dwDecodedOEP, dwImageBase, dwStartAddr );				//  
	SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), FOREGROUND_INTENSITY | FOREGROUND_GREEN);		// 
	printf("[+] CURED successfully!!!\n");
	return 0;
}